uses
  Crt, Dos, Graph;

var
  GraphDriver : integer;  { The Graphics device driver }
  GraphMode   : integer;  { The Graphics mode value }
  MaxX, MaxY  : word;     { The maximum resolution of the screen }
  ErrorCode   : integer;  { Reports any graphics errors }
  MaxColor    : word;     { The maximum color value available }
  OldExitProc : Pointer;  { Saves exit procedure address }
  ch:char;
  resto,x,y:real;
  p,po,intpo:integer;
  add:integer;
{$F+}
function pow(base,esp:real):real;
var count:integer;
    temp:real;
begin
count:=0;
temp:=1;
while (count<esp) do
begin
count:=count+1;
temp:=temp*base;
end;
pow:=temp;
end;

procedure MyExitProc;
begin
  ExitProc := OldExitProc; { Restore exit procedure address }
  CloseGraph;              { Shut down the graphics system }
end; { MyExitProc }
{$F-}

procedure Initialize;
{ Initialize graphics and report any errors that may occur }
var
  InGraphicsMode : boolean; { Flags initialization of graphics mode }
  PathToDriver   : string;  { Stores the DOS path to *.BGI & *.CHR }
begin
  { when using Crt and graphics, turn off Crt's memory-mapped writes }
  DirectVideo := False;
  OldExitProc := ExitProc;                { save previous exit proc }
  ExitProc := @MyExitProc;                { insert our exit proc in chain }
  PathToDriver := '.';
  repeat

{$IFDEF Use8514}                          { check for Use8514 $DEFINE }
    GraphDriver := IBM8514;
    GraphMode := IBM8514Hi;
{$ELSE}
    GraphDriver := Detect;                { use autodetection }
{$ENDIF}

    InitGraph(GraphDriver, GraphMode, PathToDriver);
    ErrorCode := GraphResult;             { preserve error return }
    if ErrorCode <> grOK then             { error? }
    begin
      Writeln('Graphics error: ', GraphErrorMsg(ErrorCode));
      if ErrorCode = grFileNotFound then  { Can't find driver file }
      begin
        Writeln('Enter full path to BGI driver or type <Ctrl-Break> to quit:');
        Readln(PathToDriver);
halt(1);
        Writeln;
      end
      else
        Halt(1);                          { Some other error: terminate }
    end;
  until ErrorCode = grOK;
  Randomize;                { init random number generator }
  MaxColor := GetMaxColor;  { Get the maximum allowable drawing color }
  MaxX := GetMaxX;          { Get screen resolution values }
  MaxY := GetMaxY;
end; { Initialize }


procedure CrtModePlay;
{ Demonstrate the use of RestoreCrtMode and SetGraphMode }
var
  ViewInfo : ViewPortType;
  Ch       : char;
begin
  GetViewSettings(ViewInfo);
  SetTextJustify(CenterText, CenterText);
  with ViewInfo do
  begin
    RestoreCrtmode;
  end;
end; { CrtModePlay }

procedure pset(x,y:real);
var po:integer;
resto:real;
begin
po:=trunc(80*(y)+trunc(x/8));
resto:=(x/8.0-trunc(x/8))*8;
mem[$b800:po]:=mem[$b800:po] or trunc(pow(2,7-resto));
end;

procedure line (xi,yi,xf,yf:integer);
 begin
 x:=xi;
repeat;
 y:=trunc((x-xf)*(yi-yf)/(xi-xf)+yf);
 add:=0;
 repeat;
  pset(x,y+add);
  add:=add+1;
 until ((y+add>=trunc((x+1-xf)*(yi-yf)/(xi-xf)+yf)) or keypressed);
 x:=x+1;
until ((x=xf));
end;

procedure box(xi,yi,xf,yf,fill:integer);
var y:integer;
begin
line(xi,yi,xf,yi);
line(xi,yf,xf,yf);
y:=yi;
repeat;
 if (fill=0) then
  begin
  pset(xi,y);
  pset(xf,y);
  end
 else
  begin
  line(xi,y,xf,y)
  end;
 y:=y+1;
until (y=yf);
end;

begin { program body }
  Initialize;
  CrtModePlay;
p:=10;
repeat;
 line(0,p,p,100);
 p:=p+10;
until ((ch=' ') or (p=100));

box (120,150,290,195,0);
box (20,30,40,100,1);
end.
